#!/usr/bin/python

################################################################
#
# Copyright (C) 2004 Tez Kamihira
#
# See the file "COPYING" for further information about
# the copyright and warranty status of this work.
#

import sys
import os
import string
import re

def acc_cmp(f, g):

    return ( - cmp(f[1], g[1]) )

def acc(s):

    s = string.strip(s)
    m = re.match(r"^([^;]+);\s*q\s*=\s*(\d+\.\d+)$", s)
    if m != None:
        return [m.group(1), float(m.group(2))]
    else:
        return [s, "1.0"]

class language:

    def __init__(self, browsers_will):

        o = string.split(browsers_will, ',')
        o = map(lambda x: acc(x), o)
        o.sort(acc_cmp)

        self.langs = map(lambda x: x[0], o)

    def select_from(self, servers_will):

        for i in range(len(self.langs)):
            if self.langs[i] in servers_will:
                return self.langs[i]

        if len(servers_will) > 0:
            return servers_will[0]
        else:
            return 'en-us'     # any political problem ?  :-)

def _main():

    lg = language("ja , fr;q=0.7,de;q=0.3")
    print lg.select_from(['ja'])

if __name__ == '__main__': _main()

# arch-tag: 465ea812-e252-4b28-9d44-e0952e0c3e50
