#!/usr/bin/python
"""
Define an os.walk compatible function in a portable way.

Copyright (c) 2004  Dustin Sallings <dustin@spy.net>
"""

import sys
import os

def __partition(f, l):
    yes=[]
    no=[]
    for fn in l:
        if f(fn):
            yes.append(fn)
        else:
            no.append(fn)
    return(yes, no)

def __saveit(rv, dirname, fnames):
    dirs, files = __partition(\
        (lambda x: os.path.isdir(os.path.join(dirname, x))), fnames)
    rv.append((dirname, dirs, files))

def __mywalk(top, topdown=True):
    rv=[]
    os.path.walk(top, __saveit, rv)
    if not topdown:
        rv.reverse()
    return(rv)

# Figure out which walk to define
try:
    os.walk
    walk=os.walk
except (AttributeError):
    walk=__mywalk

# arch-tag: F1193F19-440D-11D8-817C-000A957659CC
